---@generic C : Object
---@param class C
---@return C
function extends(class)
    return setmetatable({},
            { __index = class,
              __tostring = function(object)
                  return object:toString()
              end
            })
end

---@class Object
Object = {}

---[static]
---@generic T : Object
---@return T
function Object:new()
    return Object:super({})
end

---[static]
---@generic T : Object
---@param super T @instance of super class
---@return self @instance of self class
function Object:super(super)
    -- self == class
    return setmetatable(super, { __index = self})
end

---@public
---@return string
function Object:toString()
    return serpent.line(self, { comment = false })
end

function Object.requireNonNil(object)
    assert(object ~= nil)
    return object
end

--A = extends(Object)
--function A:new()
--    return A:super(Object:new())
--end
--function A:pies()
--    print("pies")
--end
--
--B = extends(A)
--function B:new()
--    return B:super(A:new())
--end
--
--C = extends(B)
--function C:new()
--    return C:super(B:new())
--end
--
--D = extends(C)
--function D:new()
--    return D:super(C:new())
--end
--
--local d = D:new()
--d:pies()
--D:pies()
