import('model.Component')
import('model.toolbar.Toolbar')

---@class AddSection : Component
AddSection = extends(Component)
AddSection.__class = "AddSection"

function AddSection:create(parent)
    local root = AddSection:createRootElement(parent, {
        type = "button",
        sprite = "interface-mod_add-section",
        style = "toolbar_button_text_wide_gray" })
    root.caption = "Add section"
    root.style.top_margin = 1 -- to do not overlap with toolbar header buttons shadows
    return AddSection:new(root)
end

function AddSection:new(element)
    return AddSection:super(Component:new(element))
end

function AddSection:handle(guiEvent)
    if guiEvent:isLeftClick() then
        Toolbar:findUp(self:parent()):addSection()
    end
end

function AddSection:lock()
    self:hide()
end

function AddSection:unlock()
    self:show()
end
