import('model.toolbar.header.ToolbarHeaderButton')

---@class DeleteToolbar : ToolbarHeaderButton
DeleteToolbar = extends(ToolbarHeaderButton)
DeleteToolbar.__class = "DeleteToolbar"

function DeleteToolbar:create(parent)
    local root = DeleteToolbar:createRootElement(parent, {
        type = "sprite-button",
        sprite = "utility/trash",
        style = "toolbar_button_icon_red" })
    return DeleteToolbar:new(root)
end

function DeleteToolbar:new(element)
    return DeleteToolbar:super(ToolbarHeaderButton:new(element))
end

function DeleteToolbar:handle(guiEvent)
    if guiEvent:isLeftClick() then
        self:header():askForDeletion()
    end
end

function DeleteToolbar:lock()
    self:hide()
end

function DeleteToolbar:unlock()
    self:show()
end
