import('model.Component')
import('model.toolbar.Toolbar')
import('model.toolbar.header.ToolbarHeader')

---@class ToolbarHeaderButton : Component
ToolbarHeaderButton = extends(Component)

function ToolbarHeaderButton:new(element)
    return ToolbarHeaderButton:super(Component:new(element))
end

---@protected
---@return Toolbar
function ToolbarHeaderButton:toolbar()
    return Toolbar:findUp(self:root())
end

---@protected
---@return ToolbarHeader
function ToolbarHeaderButton:header()
    return ToolbarHeader:findUp(self:root())
end

function ToolbarHeaderButton:lock()
    self:root().style.size = 16
end

function ToolbarHeaderButton:unlock()
    self:root().style.size = 20
end
