import('model.Component')
import('model.toolbar.section.header.SectionHeader')
import('model.toolbar.section.table.Table')

---@class Section : Component
Section = extends(Component)
Section.__class = "Section"

function Section:create(parent)
    local toolbar = Toolbar:findUp(parent):root()
    local root = Section:createRootElement(parent, {
        type = "frame",
        direction = "vertical",
        style = "toolbar_content_sections_section" })
    root.drag_target = toolbar
    SectionHeader:create(root)
    local content = root.add {
        type = "flow",
        name = "content",
        direction = "vertical",
    }
    Table:create(content)
    return Section:new(root)
end

function Section:new(element)
    return Section:super(Component:new(element))
end

function Section:childrenClasses()
    return { SectionHeader, Table }
end

function Section:moveDown()
    if #self:parent().children > self:index() then
        self:parent().swap_children(self:index(), self:index() + 1)
    end
end

function Section:moveUp()
    if self:index() > 1 then
        self:parent().swap_children(self:index(), self:index() - 1)
    end
end

function Section:collapse()
    self:table():hide()
end

function Section:expand()
    self:table():show()
end

function Section:table()
    return Table:findDownFirst(self:root())
end
