import('model.toolbar.section.header.SectionHeaderButton')
import('model.toolbar.section.header.CollapseSection')

---@class ExpandSection : SectionHeaderButton
ExpandSection = extends(SectionHeaderButton)
ExpandSection.__class = "ExpandSection"

function ExpandSection:create(parent)
    local root = ExpandSection:createRootElement(parent, {
        type = "sprite-button",
        sprite = "interface-mod_expand",
        style = "toolbar_button_icon_black" })
    return ExpandSection:new(root)
end

function ExpandSection:new(element)
    return ExpandSection:super(SectionHeaderButton:new(element))
end

function ExpandSection:handle(guiEvent)
    if guiEvent:isLeftClick() then
        self:section():expand()
    end
    self:replaceWith(CollapseSection:create(self:parent()))
end
