import('model.Component')
import('model.toolbar.section.table.Table')

---@class AddColumn : Component
AddColumn = extends(Component)
AddColumn.__class = "AddColumn"

function AddColumn:create(parent)
    local element = AddColumn:createRootElement(parent, {
        type = "sprite-button",
        sprite = "interface-mod_add-column",
        style = "toolbar_button_icon_gray" })
    return AddColumn:new(element)
end

function AddColumn:new(element)
    return AddColumn:super(Component:new(element))
end

function AddColumn:handle(guiEvent)
    if guiEvent:isLeftClick() then
        self:table():addColumn()
    end
end

---@private
---@return Table
function AddColumn:table()
    return Table:findUp(self:root())
end
