import('model.Component')
import('model.toolbar.section.table.Table')

---@class AddRow : Component
AddRow = extends(Component)
AddRow.__class = "AddRow"

function AddRow:create(parent)
    local element = AddRow:createRootElement(parent, {
        type = "sprite-button",
        sprite = "interface-mod_add-row",
        style = "toolbar_button_icon_gray" })
    element.style.right_margin = 5
    return AddRow:new(element)
end

function AddRow:new(element)
    return AddRow:super(Component:new(element))
end

function AddRow:handle(guiEvent)
    if guiEvent:isLeftClick() then
        self:table():addRow()
    end
end

---@private
---@return Table
function AddRow:table()
    return Table:findUp(self:root())
end
