import('lang.Object')
import('model.toolbar.section.table.Table')

---@class DeleteColumn : Component
DeleteColumn = extends(Component)
DeleteColumn.__class = "DeleteColumn"

function DeleteColumn:create(parent)
    local element = DeleteColumn:createRootElement(parent, {
        type = "sprite-button",
        sprite = "interface-mod_delete-column",
        style = "toolbar_button_icon_gray" })
    return DeleteColumn:new(element)
end

function DeleteColumn:new(element)
    return DeleteColumn:super(Component:new(element))
end

function DeleteColumn:handle(guiEvent)
    if guiEvent:isLeftClick() then
        self:table():tryRemovingLastColumn()
    end
end

---@private
---@return Table
function DeleteColumn:table()
    return Table:findUp(self:root())
end
