import('model.Component')
import('model.toolbar.section.table.Table')

---@class DeleteRow : Component
DeleteRow = extends(Component)
DeleteRow.__class = "DeleteRow"

function DeleteRow:create(parent)
    local element = DeleteRow:createRootElement(parent, {
        type = "sprite-button",
        sprite = "interface-mod_delete-row",
        style = "toolbar_button_icon_gray" })
    return DeleteRow:new(element)
end

function DeleteRow:new(element)
    return DeleteRow:super(Component:new(element))
end

function DeleteRow:handle(guiEvent)
    if guiEvent:isLeftClick() then
        self:table():tryRemovingLastRow()
    end
end

---@private
---@return Table
function DeleteRow:table()
    return Table:findUp(self:root())
end
