import('lang.Object')
import('model.toolbar.section.table.Slot')

---@class Item : Slot
Item = extends(Slot)
Item.__class = "Item"

function Item:create(parent, itemName)
    local element = Item:createRootElement(parent, {
        type = "sprite-button",
        elem_tooltip = { type = "item", name = itemName },
        sprite = "item/" .. Object.requireNonNil(itemName),
        style = "toolbar_content_sections_section_content_table_content_row_slot",
        mouse_button_filter = { "left", "middle" },
    })
    local item = Item:new(element)
    item:update()
    return item
end

function Item:new(element)
    return Item:super(Slot:new(element))
end

---@param guiEvent GuiEvent
function Item:handle(guiEvent)
    if guiEvent:isLeftClick() then
        local itemName = self:itemName()
        if self:inventory():hasItem(itemName) then
            self:inventory():pick(itemName)
        else
            self:cursor():pickGhost(itemName)
        end
        self:rememberPick()
    elseif guiEvent:isMiddleClick() then
        self:clear()
    end
end

function Item:update()
    local count = self:inventory():countOf(self:itemName())
    self:root().number = count > 0 and count or nil
end

function Item:itemName()
    return self:root().elem_tooltip.name
end
