import('lang.Object')
import('model.toolbar.section.table.Slot')

---@private
---@class Tool : Slot
Tool = extends(Slot)
Tool.__class = "Tool"

function Tool:create(parent, itemName)
    local element = Tool:createRootElement(parent, {
        type = "sprite-button",
        elem_tooltip = { type = "item", name = itemName },
        sprite = "item/" .. Object.requireNonNil(itemName),
        style = "toolbar_content_sections_section_content_table_content_row_slot",
        mouse_button_filter = { "left", "middle" } })
    return Tool:new(element)
end

function Tool:new(element)
    return Tool:super(Slot:new(element))
end

function Tool:handle(guiEvent)
    if guiEvent:isLeftClick() then
        self:cursor():pickTool(self:itemName())
        self:rememberPick()
    elseif guiEvent:isMiddleClick() then
        self:clear()
    end
end

function Tool:itemName()
    return self:root().elem_tooltip.name
end
